## golang-github-google-flatbuffers 24.3.25

=== debian/changelog ===
golang-github-google-flatbuffers (24.3.25-2) unstable; urgency=medium

  * No change source-only upload.

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 17 Dec 2024 18:08:20 +0100

golang-github-google-flatbuffers (24.3.25-1) unstable; urgency=medium

  * Initial release (Closes: #1087287)

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 10 Nov 2024 19:37:02 +0100
