=== debian/changelog ===
golang-github-google-flatbuffers (24.12.23-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 04 Jan 2025 12:02:34 +0100
