=== debian/control ===
Source: golang-github-google-flatbuffers
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Andreas Henriksson <andreas@fatal.se>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-google-flatbuffers
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-google-flatbuffers.git
Homepage: https://github.com/google/flatbuffers
XS-Go-Import-Path: github.com/google/flatbuffers

Package: golang-github-google-flatbuffers-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: FlatBuffers: Memory Efficient Serialization Library (library)
 FlatBuffers is a cross platform serialization library architected
 for maximum memory efficiency. It allows you to directly access
 serialized data without parsing/unpacking it first, while still having
 great forwards/backwards compatibility.
 .
 This package contains the development files for Go(lang).
